// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/search/FilterModel"],function(e){describe("FilterModel",function(){var t,n;beforeEach(function(){t={filters:jasmine.createSpy()},n=new e(t)}),it("defines some attributes",function(){expect(n.filter).toBeDefined(),expect(n.compareType).toBeDefined(),expect(n.value).toBeDefined(),expect(n.values).toBeDefined(),expect(n.filterName).toBeDefined(),expect(n.compareTypeName).toBeDefined()}),it("blanks the values property when the filter property changes",function(){n.filter("filter1"),n.compareType("=="),n.values(["catpants"]),expect(n.values().length).toEqual(1),n.filter("filter2"),expect(n.values().length).toEqual(0)}),it("is complete when all values are satisfied for single value case",function(){n.filter("filter"),expect(n.complete()).toBeFalsy(),n.compareType("=="),expect(n.complete()).toBeFalsy(),n.value("value"),expect(n.complete()).toBeTruthy()}),it("is complete when all values are satisfied for multi-value case",function(){n.filter("filter"),expect(n.complete()).toBeFalsy(),n.compareType("=="),expect(n.complete()).toBeFalsy(),n.values(["value1","value2"]),expect(n.complete()).toBeTruthy()}),it("knows how to compare against others of its type in single value case",function(){var t=new e;t.filter("filter"),t.compareType("=="),t.value("value"),n.filter("filter"),n.compareType("=="),n.value("value"),expect(n.compareTo(t)).toBeTruthy(),t.filter("bad"),expect(n.compareTo(t)).toBeFalsy(),t.filter(n.filter()),t.compareType("bad"),expect(n.compareTo(t)).toBeFalsy(),t.compareType(n.compareType()),t.value("bad"),expect(n.compareTo(t)).toBeFalsy(),t.value(n.value()),expect(n.compareTo(t)).toBeTruthy()}),it("knows how to compare against others of its type in multi-value case with different order",function(){var t=new e;t.filter("filter"),t.compareType("=="),t.values(["value1","value2"]),n.filter("filter"),n.compareType("=="),n.values(["value2","value1"]),expect(n.compareTo(t)).toBeTruthy()}),it("can compare to falsy correctly",function(){expect(n.compareTo(null)).toBeFalsy(),expect(n.compareTo(undefined)).toBeFalsy()}),it("sets filter properly by name",function(){var e={propertyName:"catpants"},r={propertyName:"doggiehat"};t.filters.andReturn([e,r]),n.filterName("doggiehat"),expect(n.filter()).toEqual(r),n.filterName("horsepoo"),expect(n.filter()).toEqual(null)}),it("tracks filter name as a property",function(){n.filter({propertyName:"catpants"}),expect(n.filterName()).toEqual("catpants"),n.filter({propertyName:"doggiehat"}),expect(n.filterName()).toEqual("doggiehat")}),it("is careful about setting compareType by name when filter is null",function(){n.filter(null),n.compareTypeName("catpants"),expect(n.compareTypeName()).toBeFalsy()}),it("sets compareType by name",function(){var e={name:"catpants"},t={name:"doggiehat"};n.filter({compareTypes:[e,t]}),n.compareTypeName("doggiehat"),expect(n.compareType()).toEqual(t),n.compareTypeName("horsepoo"),expect(n.compareType()).toEqual(null)}),it("provides values as comma-delimited string",function(){expect(n.value()).toEqual(""),n.values(["catpants","doggiehat"]),expect(n.value()).toEqual("catpants,doggiehat")}),it("allows values to be set as comma-delimited string",function(){expect(n.values().length).toEqual(0),n.value("catpants,doggiehat"),expect(n.values().length).toEqual(2);var e=n.values();expect(e[0]).toEqual("catpants"),expect(e[1]).toEqual("doggiehat")})})})